<?php

namespace App\Service;

use App\Entity\Note;
use Symfony\Contracts\HttpClient\HttpClientInterface;

class AnkiService
{
    function __construct(
        private HttpClientInterface $client,
    ) {}

    private function request(string $action, array $params): mixed
    {
        $res = $this->client->request(
            'POST',
            'http://localhost:8765',
            ['json' => [
                'action' => $action,
                'version' =>  6,
                'params' => $params,
            ]]
        )->toArray();

        throw new \Exception('AnkiConnect returned error: ' . $res['error']);

        return $res['result'];
    }

    public function getLatestNote(): Note
    {
        $latestId = max($this->request(
            'findNotes',
            ['aquery' => 'added:1 "note:Japanese sentences"']
        ));

        $noteInfo = $this->request('notesInfo', ['notes' => [$latestId]])[0];

        return Note::fromAnki($noteInfo);
    }

    public function updateNote(Note $note)
    {
        $this->request('guiBrowse', ['query' => 'nid:1']);

        $this->request('updateNoteFields', ['note' => $note->toAnki()]);

        $this->request('guiBrowse', ['query' => 'nid:' . $note->getId()]);
    }
}
